#ifndef __UART_H
#define	__UART_H


#ifndef BIT
#define BIT(n)              (1 << (n))
#endif

#define VIC_UART0       6
#define VIC_UART1       7

#define UART_BAUD(baud) (unsigned short)((PCLK / ((baud) * 16.0)) + 0.5)
#define B1200         UART_BAUD(1200)
#define B9600         UART_BAUD(9600)
#define B19200        UART_BAUD(19200)
#define B38400        UART_BAUD(38400)
#define B57600        UART_BAUD(57600)
#define B115200       UART_BAUD(115200)
#define B230400       UART_BAUD(230400)

#define UART_8N1      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_NO   + ULCR_STOP_1)
#define UART_7N1      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_NO   + ULCR_STOP_1)
#define UART_8N2      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_NO   + ULCR_STOP_2)
#define UART_7N2      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_NO   + ULCR_STOP_2)
#define UART_8E1      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_EVEN + ULCR_STOP_1)
#define UART_7E1      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_EVEN + ULCR_STOP_1)
#define UART_8E2      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_EVEN + ULCR_STOP_2)
#define UART_7E2      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_EVEN + ULCR_STOP_2)
#define UART_8O1      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_ODD  + ULCR_STOP_1)
#define UART_7O1      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_ODD  + ULCR_STOP_1)
#define UART_8O2      (unsigned char)(ULCR_CHAR_8 + ULCR_PAR_ODD  + ULCR_STOP_2)
#define UART_7O2      (unsigned char)(ULCR_CHAR_7 + ULCR_PAR_ODD  + ULCR_STOP_2)

#define UART_FIFO_OFF (0x00)
#define UART_FIFO_1   (unsigned char)(UFCR_FIFO_ENABLE + UFCR_FIFO_TRIG1)
#define UART_FIFO_4   (unsigned char)(UFCR_FIFO_ENABLE + UFCR_FIFO_TRIG4)
#define UART_FIFO_8   (unsigned char)(UFCR_FIFO_ENABLE + UFCR_FIFO_TRIG8)
#define UART_FIFO_14  (unsigned char)(UFCR_FIFO_ENABLE + UFCR_FIFO_TRIG14)

extern unsigned char UART_Received;

void UART_0Init(unsigned short baud, unsigned char mode, unsigned char fmode);
int UART_0Putch(unsigned char ch);
int UART_0Getch(void);
const char *UART_0Puts(const char *string);
int UART_0GetchW(void);

#endif
